<?php
/*
Plugin Name: Audit of your website
Plugin URI: 
Description: Scan modied files, and detect eval function
Version: 2.0	
Author: NIZON Yohann
Author URI: http://www.gameandme.fr
*/


global $wpdb;
global $iNbEvalFile;
global $iNbFilesmanFile;
global $plugin_path;
global $is_wordpress;

$is_wordpress = false;

//////////////////////////////////////////////////
// SPECIFIC FOR WORDPRESS
//////////////////////////////////////////////////
// CRON - 1 by DAY
if (function_exists("add_filter")){
	$is_wordpress = true;
	add_filter( 'cron_schedules', 'audit_add_cron_intervals' );
	$plugin_path = dirname(__FILE__)."/";

	function audit_add_cron_intervals( $schedules ) {
	   $schedules['audit_event'] = array( // Provide the programmatic name to be used in code
		  'interval' => 86400, // Intervals are listed in seconds 
		  'display' => __('Every Day') // Easy to read display name
	   );
	   return $schedules; // Do not forget to give back the list of schedules!
	}

	add_action( 'audit_cron_hook3', 'audit_cron_exec' );

	if( !wp_next_scheduled( 'audit_cron_hook3' ) ) {
	   wp_schedule_event( time(), 'audit_event', 'audit_cron_hook3' );
	}

	function audit_cron_exec() {
		global $plugin_path;
		$root_folder = dirname(dirname(dirname($plugin_path))) ."/";//Take the root folder from audit plugin
		check_all_files(true,true, true, $plugin_path,$root_folder);
	}

	// Menu
	function audit_lead_menu() {
		//Add entry menu plugins
		add_menu_page('Audit', 'Audit', 'read', basename(__FILE__), 'audit_homepage', site_url("/wp-content/plugins/audit") . '/audit.jpg');	
	}

	add_action('admin_menu','audit_lead_menu');
}else{
	audit_homepage();
}
//////////////////////////////////////////////////



/* Check ROOT Files */
function check_all_files($bEval = true, $bScan = true, $bHash = true, $plugin_path, $root_folder){ 
	global $wpdb;
	global $iNbEvalFile;
	global $iNbFilesmanFile;
	global $is_wordpress;
	
	
	
	$iNbEvalFile = 0;
	$iNbFilesmanFile = 0;
	
	//set_time_limit(180);
		
	
	$tabReturn = array();
	$tabReturn["eval"] = array(); 
	$tabReturn["filesman"] = array(); 
	$tabReturn["update"] = array(); 
	$tabReturn["upload"] = array(); 
	$tabReturn["admin"] = array(); 
	$tabReturn["so"] = array(); 
	
	//Set settings file
	$tabOptions = array();	
	if (file_exists($plugin_path."options.txt")){
		$tabOptions = unserialize(file_get_contents($plugin_path."options.txt"));
	}else{
		$tabOptions["email"] = "";
		if (function_exists("get_option")){
			$tabOptions["email"] = get_option('admin_email');
		}
		$tabOptions["hash"] = "";
		
		$tabOptions["admin"] = array();
		//Get list of administrator
		if ($is_wordpress){
			$blogusers = get_users( 'blog_id=1&orderby=nicename&role=administrator' );
			foreach ( $blogusers as $user ) {
				$tabOptions["admin"][] = $user->user_email;
			}
		}
	}
	
	if (isset($_POST["email"])){
		$tabOptions["email"] = $_POST["email"];
	}
	if (isset($_POST["hash"])){
		$tabOptions["hash"] = $_POST["hash"];
	}
	
	if (isset($_POST["exclude_dirs"])){
		file_put_contents($plugin_path."exclude.txt",$_POST["exclude_dirs"]);
	}
	
	if ($is_wordpress){
		//Check new administrator users
		$blogusers = get_users( 'blog_id=1&orderby=nicename&role=administrator' );
		foreach ( $blogusers as $user ) {
			if (!in_array($user->user_email,$tabOptions["admin"])){
				$tabReturn["admin"][] = $user->user_email;
			}
		}
		
		//Reset list of administrator
		$tabOptions["admin"] = array();
		$blogusers = get_users( 'blog_id=1&orderby=nicename&role=administrator' );
		foreach ( $blogusers as $user ) {
			$tabOptions["admin"][] = $user->user_email;
		}	
	}
	file_put_contents($plugin_path."options.txt",serialize($tabOptions));
	
	
	
	
	$tabExclude = explode("\n",audit_get_exclude());	
	
	if (!file_exists($plugin_path."logs")){
		mkdir($plugin_path."logs");
	}
	
	
	if ($bScan){
		$tabReturn = check_folder($root_folder,$tabExclude, $tabReturn,$bEval, $plugin_path);
		
		//Check the last file to see different
		$iOldSize = 0;
		$sOldContenu = "";
		if (file_exists($plugin_path."scan.txt")){
			$iOldSize = filesize($plugin_path."scan.txt");
			$sOldContenu = file_get_contents($plugin_path."scan.txt");
		}
		
		
		$fp = fopen($plugin_path."scan.txt","w+");
				
		$sMsgEmail = "";
		if (count($tabReturn["admin"])> 0){	
			fputs ($fp, "\r\nNEW ADMINISTRATOR USERS:\r\n");
			$sMsgEmail .= "\r\nNEW ADMINISTRATOR USERS:\r\n";
			foreach ($tabReturn["admin"] as $sReturn){
				fputs ($fp, $sReturn."\r\n");
				$sMsgEmail .= $sReturn."\r\n";
			}
			
		}
		
		if (count($tabReturn["eval"])> 0){
			fputs ($fp, "\r\nEVAL FOUND, PLEASE CHECK THESE FILES MANUALLY:\r\n");
			$sMsgEmail .= "\r\nEVAL FOUND, PLEASE CHECK THESE FILES MANUALLY:\r\n";
			foreach ($tabReturn["eval"] as $sReturn){
				fputs ($fp, $sReturn."\r\n");
				$sMsgEmail .= $sReturn."\r\n";
			}
		}
		
		if (count($tabReturn["filesman"])> 0){
			fputs ($fp, "\r\nFILESMAN FOUND, PLEASE CHECK THESE FILES MANUALLY:\r\n");
			$sMsgEmail .= "\r\nFILESMAN FOUND, PLEASE CHECK THESE FILES MANUALLY:\r\n";
			foreach ($tabReturn["filesman"] as $sReturn){
				fputs ($fp, $sReturn."\r\n");
				$sMsgEmail .= $sReturn."\r\n";
			}
		}
		
		if (count($tabReturn["so"])> 0){
			fputs ($fp, "\r\nSO FILES FOUND IN YOUR DIRECTORY:\r\n");
			$sMsgEmail .= "\r\nSO FILES FOUND IN YOUR DIRECTORY:\r\n";
			foreach ($tabReturn["so"] as $sReturn){
				fputs ($fp, $sReturn."\r\n");
				$sMsgEmail .= $sReturn."\r\n";
			}
		}
		
		if (count($tabReturn["upload"])> 0){
			fputs ($fp, "\r\nPHP FILES FOUND IN YOUR UPLOAD DIRECTORY:\r\n");
			$sMsgEmail .= "\r\nPHP FILES FOUND IN YOUR UPLOAD DIRECTORY:\r\n";
			foreach ($tabReturn["upload"] as $sReturn){
				fputs ($fp, $sReturn."\r\n");
				$sMsgEmail .= $sReturn."\r\n";
			}
		}
		
		if (count($tabReturn["update"])> 0){
			fputs ($fp, "\r\nPHP FILES MODIFIED FROM THE LAST SCAN:\r\n");
			$sMsgEmail .= "\r\nPHP FILES MODIFIED FROM THE LAST SCAN:\r\n";
			foreach ($tabReturn["update"] as $sReturn){
				fputs ($fp, $sReturn."\r\n");
				$sMsgEmail .= $sReturn."\r\n";
			}
		}
		
		//Add difference for post content
		$sMsgHashCode = "";
		if ($bHash){
			$sMsgHashCode = audit_hashPost();
			if ($sMsgHashCode != ""){
				$sMsgEmail .= $sMsgHashCode;
				fputs ($fp, $sMsgHashCode."\r\n");
			}
		}
		
		fclose($fp);
		
		
		//Not sending the same report twice
		$sNewContenu = file_get_contents($plugin_path."scan.txt");
		
		if (filesize($plugin_path."scan.txt")>0 and $sNewContenu != $sOldContenu and $sMsgEmail!= ""){
			echo "Email send<br/>";
			// To
			$to = $tabOptions["email"];
			if ($to != ""){
				$from = "audit@yourwebsite.com"; 
				 
				//=====Définition du sujet.				
				if ($is_wordpress){
					$sujet .= 'Wordpress - Audit Plugin > Hack detected for '.get_site_url();
				}else{
					$sujet = 'Audit of Website > Hack detected';
				}
				//=========


				$mail = $to; // Déclaration de l'adresse de destination.
				if (!preg_match("#^[a-z0-9._-]+@(hotmail|live|msn).[a-z]{2,4}$#", $mail)) // On filtre les serveurs qui présentent des bogues.
				{
					$passage_ligne = "\r\n";
				}
				else
				{
					$passage_ligne = "\n";
				}
				//=====Déclaration des messages au format texte et au format HTML.
				$message_txt = "Hack detected\r\nSome files have been modified, you will get the detail with the attachment below. You receive this mail because you have activate the audit plugin in your wordpress ".get_site_url()."\r\n\r\n".$sMsgEmail;
				$message_html = "<html><head></head><body>".str_replace("\r\n","<br/>",$message_txt)."</body></html>";
				//==========
				 
				//=====Lecture et mise en forme de la pièce jointe.
				$file_name = $plugin_path."scan.txt";
				if (file_exists($file_name))
				{
					$fichier   = fopen($file_name, "r");
					$attachement = fread($fichier, filesize($file_name));
					$attachement = chunk_split(base64_encode($attachement));
					fclose($fichier);
				}
				//==========
				 
				//=====Création de la boundary.
				$boundary = "-----=".md5(rand());
				$boundary_alt = "-----=".md5(rand());
				//==========
				
				 
				//=====Création du header de l'e-mail.
				$header = "From: \"Audit\"<".$from.">".$passage_ligne;
				$header.= "Reply-to: \"Audit\" <".$from.">".$passage_ligne;
				$header.= "MIME-Version: 1.0".$passage_ligne;
				$header.= "Content-Type: multipart/mixed;".$passage_ligne." boundary=\"$boundary\"".$passage_ligne;
				//==========
				 
				//=====Création du message.
				$message = $passage_ligne."--".$boundary.$passage_ligne;
				$message.= "Content-Type: multipart/alternative;".$passage_ligne." boundary=\"$boundary_alt\"".$passage_ligne;
				$message.= $passage_ligne."--".$boundary_alt.$passage_ligne;
				//=====Ajout du message au format texte.
				$message.= "Content-Type: text/plain; charset=\"ISO-8859-1\"".$passage_ligne;
				$message.= "Content-Transfer-Encoding: 8bit".$passage_ligne;
				$message.= $passage_ligne.$message_txt.$passage_ligne;
				//==========
				 
				$message.= $passage_ligne."--".$boundary_alt.$passage_ligne;
				 
				//=====Ajout du message au format HTML.
				$message.= "Content-Type: text/html; charset=\"ISO-8859-1\"".$passage_ligne;
				$message.= "Content-Transfer-Encoding: 8bit".$passage_ligne;
				$message.= $passage_ligne.$message_html.$passage_ligne;
				//==========
				 
				//=====On ferme la boundary alternative.
				$message.= $passage_ligne."--".$boundary_alt."--".$passage_ligne;
				//==========
				 
				 
				 
				$message.= $passage_ligne."--".$boundary.$passage_ligne;
				 
				//=====Ajout de la pièce jointe.
				$message.= "Content-Type: image/jpeg; name=\"scan.txt\"".$passage_ligne;
				$message.= "Content-Transfer-Encoding: base64".$passage_ligne;
				$message.= "Content-Disposition: attachment; filename=\"scan.txt\"".$passage_ligne;
				$message.= $passage_ligne.$attachement.$passage_ligne.$passage_ligne;
				$message.= $passage_ligne."--".$boundary."--".$passage_ligne; 
				//========== 
				//=====Envoi de l'e-mail.
				mail($mail,$sujet,$message,$header);
				 
				//==========

			}
		}
	}
}



/* Check folder */
function check_folder($sFolder, $tabExclude, $tabReturn,$bEval, $plugin_path){
	global $iNbEvalFile;	
	global $iNbFilesmanFile;
	global $is_wordpress;
	
	
	$root_folder = dirname(__FILE__)."/";
	if ($is_wordpress){
		$root_folder = dirname(dirname(dirname($plugin_path)))."/";//Take the root folder from audit plugin
	}
	
	//Exception for this file and 2 wordpress core page
	$tabFilesException = array("wp-admin/press-this.php","wp-content/plugins/audit/index.php","wp-includes/class-json.php","wp-admin/includes/class-pclzip.php");

	$b = true;
	foreach ($tabExclude as $sExclude){
		$sExclude = str_replace("\n","",$sExclude);
		$sExclude = str_replace("\r","",$sExclude);
		if ($sExclude != ""){				
			$sExcludeFile = $root_folder."/".$sExclude;
			if (!is_file($sExcludeFile)){			
				if (strpos($sFolder,$sExclude) !== false){
					$b = false;
				}
			}else{
				//$sExclude = str_replace("../","",$sExclude);
				//$sExclude = str_replace("./","",$sExclude);
				$tabFilesException[] = $sExclude;
			}			
		}
	}	
		
		
	if ($b){		
		$plugin_path_log = $plugin_path."logs/";
		$tabFiles = scandir($sFolder);
		foreach ($tabFiles as $sFile){
			if ($sFile != "." and $sFile != ".."){
				if (is_dir($sFolder.$sFile)){
					$tabReturn = check_folder($sFolder.$sFile."/", $tabExclude, $tabReturn, $bEval, $plugin_path);
				}else{
									
					//Check if php file
					$tabFile = explode(".",$sFile);
					if (count($tabFile)>0){
						if (strtolower($tabFile[count($tabFile)-1]) == "sd0" or strtolower($tabFile[count($tabFile)-1]) == "sh" or strtolower($tabFile[count($tabFile)-1]) == "so"){
							$tabReturn["so"][] = $sFolder.$sFile;
						}else{
							if (strtolower($tabFile[count($tabFile)-1]) == "php" or strtolower($tabFile[count($tabFile)-1]) == "php5" or strtolower($tabFile[count($tabFile)-1]) == "htaccess"){
								$sFolder2 = $sFolder;
								$sFolder2 = str_replace($root_folder,"",$sFolder2);
								//$sFolder2 = str_replace("./","",$sFolder2);																
								
								$bChkEval=false;
								if ($bEval and !in_array($sFolder2.$sFile,$tabFilesException)){
									$file_handle = fopen($sFolder.$sFile, "r");
									
									while (!feof($file_handle) and $bChkEval==false) {
										$line_of_text = fgets($file_handle);
										//\x65\x76\x61\x6C\x28 = eval( in hexa
										if ((strpos(strtolower($line_of_text),"\x65\x76\x61\x6C\x28") !== false or strpos(strtolower($line_of_text),"eval(") !== false) and strpos(strtolower($line_of_text),"doubleval(") === false and strpos(strtolower($line_of_text),"directly eval()") === false){
											$bChkEval= true;						
										}
									}
									fclose($file_handle);
								}
								
								if ($bChkEval){
									$iNbEvalFile++;
									$tabReturn["eval"][] = $sFolder2.$sFile;
								}
								
								
								$bChkFilesMan=false;
								if ($bEval and !in_array($sFolder2.$sFile,$tabFilesException)){
									$file_handle = fopen($sFolder.$sFile, "r");
									
									while (!feof($file_handle) and $bChkFilesMan==false) {
										$line_of_text = fgets($file_handle);
										if (strpos(strtolower($line_of_text),"filesman") !== false){
											$bChkFilesMan= true;						
										}
									}
									fclose($file_handle);
								}
								
								if ($bChkFilesMan){
									$iNbFilesmanFile++;
									$tabReturn["filesman"][] = $sFolder2.$sFile;
								}
								
								
								//Check PHP File on Upload directory
								if (strpos($sFolder,"wp-content/uploads/") !== false){
									$tabReturn["upload"][] = $sFolder2.$sFile;
								}
								
								//Write filesize for each file								
								if (file_exists($plugin_path_log.md5($sFolder2.$sFile).".txt")){
									$sFilesize = file_get_contents($plugin_path_log.md5($sFolder2.$sFile).".txt");
									if ($sFilesize != filesize  ($sFolder.$sFile)){
										$tabReturn["update"][] = $sFolder2.$sFile;
									}
								}							
								
								file_put_contents($plugin_path_log.md5($sFolder2.$sFile).".txt",filesize  ($sFolder.$sFile));
							}
						}
					}
				}
			}
		}
	}
	
	return $tabReturn;
}

/* Get exclude dir */
function audit_get_exclude(){
	global $plugin_path;
	$sExclude = "";	
	if (file_exists($plugin_path."exclude.txt")){
		$sExclude = file_get_contents($plugin_path."exclude.txt");
	}
	
	return $sExclude;
}

/* Homepage */
function audit_homepage(){
	global $iNbEvalFile;
	global $iNbFilesmanFile;
	global $plugin_path;
	global $is_wordpress;
	
	$bScan = false;
	if (isset($_POST["email"])){
		$bScan = true;
	}
	$bHash = false;
	if (isset($_POST["hash"])){
		$bHash = true;
	}
	
	$root_folder = dirname(__FILE__)."/";
	if ($is_wordpress){
		$root_folder = dirname(dirname(dirname($plugin_path)))."/";//Take the root folder from audit plugin
	}
	
	check_all_files(true,$bScan, $bHash, $plugin_path,$root_folder);
	$tabOptions = unserialize(file_get_contents($plugin_path."options.txt"));
	$sExclude = audit_get_exclude();	
	?>
	<br/>
	
	<br/>
	<h1>Audit - Prevent from hacking</h1>
	This plugin scann all your PHP, htaccess files and detect changes.<br/>	
	It detects too base64_decode and Files Manager corrupt files.<br/>
	It scan also .so (shared object) and .sd0 and .sh files.<br/>
	You can set some files and directories for exclude them of scanning.<br/>
	It detect also new administrator users.<br/>
	You will get an email if some changes are detected with the detail (1 by day).<br/>
	Somes files are excluded of scanning like this page, and some Wordpress core pages.<br/>
	It detects also old content which has been modified.<br/>
	
	<?php
	$folder_download = "";
	if ($is_wordpress){
		$folder_download = "../wp-content/plugins/audit/";
		$iNbTheme = 0;
		$tabThemes = scandir("../wp-content/themes");
		foreach ($tabThemes as $sTheme){
			if ($sTheme != ".." and $sTheme!="."){
				if (is_dir("../wp-content/themes/".$sTheme)){
					$iNbTheme++;
				}
			}
		}
		
		if ($iNbTheme > 1){
			echo "<br/><h2>You have ".$iNbTheme." themes, please delete useless themes for better protection.</h2><br/>";
		}
	}
	
	if (file_exists($plugin_path."scan.txt")){
		if (filesize($plugin_path."scan.txt") > 0){	
	?>
			<a target="_blank" href='<?php echo $folder_download;?>scan.txt'>Download Detail</a>
	<?php
		}else{
			echo "<br/>Scanning OK: No problem detected";
		}
	}
		
	?>
	
	<br/><br/>
	<form method='post'>
		<table>
			<tr>
				<td>Excludes files and directories</td>
				<td><textarea name="exclude_dirs" cols="60" rows="10"><?php echo $sExclude;?></textarea></td>
			</tr>
			
			<tr>
				<td>Email to prevent</td>
				<td><input type="text" value="<?php echo $tabOptions["email"];?>" name="email" /></td>
			</tr>
			<tr>
				<td>Add modify control for older post</td>
				<td><input type="checkbox" value="1" <?php if ($tabOptions["hash"]==1){echo "checked";} ?> name="hash" /></td>
			</tr>
			<tr>
				<td></td>
				<td><input type="submit" value="Save and scan"/></td>
			</tr>
		</table>		
	</form>
	<?php
}

/* Hash all text posts to detect hack in old content */
function audit_hashPost(){
	global $wpdb;
	$sql = "CREATE TABLE IF NOT EXISTS ".$wpdb->prefix."posts_hash (
		  `post_id` bigint(20) NOT NULL,
		  `hashcode` varchar(200) NOT NULL,
		  `recent_hashcode` varchar(200) NOT NULL,
		  `post_title` text,
		  PRIMARY KEY (`post_id`)
		) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";	
	$res = $wpdb->get_results($sql);
	
	//We write hashcode for older post
	$older_date= date("Y-m-d H:i:s",strtotime("-15 day")); 	
	$sql = "SELECT md5(post_content) as md5code,".$wpdb->prefix."posts.post_title, ID , hashcode, recent_hashcode
		FROM ".$wpdb->prefix."posts 
		LEFT JOIN ".$wpdb->prefix."posts_hash ON ".$wpdb->prefix."posts_hash.post_id = ".$wpdb->prefix."posts.ID
		where post_status = 'publish' and post_date <= '".$older_date."'";	
	
	$res = $wpdb->get_results($sql);
	
	foreach ($res as $q){
		if ($q->hashcode == ""){
			$wpdb->query( 
				$wpdb->prepare( 
					"
						INSERT INTO ".$wpdb->prefix."posts_hash (post_title,post_id,hashcode,recent_hashcode) VALUES (%s,%s,%s,%s)
					",
						$q->post_title, $q->ID, $q->md5code, $q->md5code
					)
			);
		}else{
			$wpdb->query( 
				$wpdb->prepare( 
					"
						UPDATE ".$wpdb->prefix."posts_hash SET recent_hashcode = %s,post_title =%s where post_id = %s
					",
						 $q->md5code, $q->post_title, $q->ID
					)
			);
		}
	}
	
	//Compare new and older hashcode
	$sMsg = "";
	$sql = "SELECT post_id , post_title
		FROM ".$wpdb->prefix."posts_hash
		where hashcode != recent_hashcode";	
	
	$res = $wpdb->get_results($sql);
	foreach ($res as $q){
		$sMsg .= " - ".$q->post_id . ": ".$q->post_title."\r\n";
		//Update with new hashcode
		$wpdb->query( 
			$wpdb->prepare( 
				"
					UPDATE ".$wpdb->prefix."posts_hash SET hashcode = recent_hashcode where post_id = %s
				",
					 $q->ID
				)
		);
	}
	
	if ($sMsg != ""){
		$sMsg = "\r\nList of post where content has been modified:\r\n".$sMsg;
	}
	
	return $sMsg;
}
?>